#include "mttypes.h"
#include "hdlc.h"

mt_uint16 fcs_update(mt_uint8 Byte, mt_uint16 cur_fcs)
{
	mt_uint32 i;
	mt_uint16 fcs_reg = cur_fcs ^ Byte;
	for (i = 0; i < 8; i++)
		fcs_reg = (fcs_reg>>1) ^ ((fcs_reg & 0x0001) ? HDLC_CRC_GENPOL : 0);
	return fcs_reg;
}

mt_uint16 compute_crc_16(mt_uint8* inputbuf, mt_uint32 inputbuflen)
{
	mt_uint16 fcs = HDLC_FCS_INIT;
	mt_uint8  txbyte,i;

	i = 0;
	while(inputbuflen--){
		txbyte = inputbuf[i++];
		fcs = fcs_update(txbyte,fcs);
	}
	fcs = ~fcs;

	return fcs;
}
